<?php

class FusionSetup extends CFormModel {

    protected $fusionconfig="/etc/apache/conf.d/95-raperca-ro.conf";
    protected $fusionstartup="/etc/apache/conf.d/30-fusion-redirect.conf";
    protected $fusionpwd="/var/lib/fusion/data/userpwd.txt";
    
    protected $needreload;
    
    public $activate;
    
    public function rules() {
		$res = array(
            array ( "start", 'safe' ),
            array ( "active", 'safe', 'on'=>'backup' ),
    	);
        return $res;
	}
    public function attributeLabels()
	{
        $labels = array(
            'start'=>'Make Fusion my default start page',
            );
        return $labels;
	}
    function getDefault() {
        return !file_exists( $this->fusionpwd ) ;
    }
    function getActive() {
        return file_exists( $this->fusionconfig ) ;
        
    }
    function setActive( $active ) {
        if ( $active )
            $this->activate();
        else
            $this->disabling();
        
    }
    function setStart( $value ) {
        
        if ( $value ){
             Yii::app()->user->tools->save_symlink( basename($this->fusionstartup).".tmpl", $this->fusionstartup );
        } else {
            unlink( $this->fusionstartup );
        }
        $this->needreload = true;
    }
    
    function startFusion() {
        return file_exists( $this->fusionstartup ) ;
    }
    
    function startControlCenter( ) {
        if ( !$this->getActive() ) // No fusion activated, not stating with it
            return true; 
        return !$this->startFusion();
    }
    function getStart( ) {
        if ( !$this->getActive() ) // make startup page by default
            return true; 
        return $this->startFusion();
        
    }
    protected function delTree($dir, $delroot=true) {
        if (substr($dir,-1,1)=='/') $dir = substr($dir,0,-1);
        $alldel=true;
        if (!file_exists($dir)) 
            return true;
        if (!is_dir($dir) || is_link($dir)) 
            return unlink($dir);
        foreach (scandir($dir) as $item) {
            if ($item == '.' || $item == '..' ) 
                continue;
            if ( $item == '.svn' ) {
                $alldel=false;    
                continue;
            }
            if (!$this->delTree($dir . "/" . $item)) 
                $alldel=false;    
        }
        if ( $delroot && $alldel )
            return rmdir($dir);
        else 
            return $alldel; 
    } 
    
    function clear() {
        $this->delTree("/srv/raperca/content/", false);
    }
    
    function activate() {
        if ( $this->getActive() )
            return;
        // stop WebDAV on fusion area
        Yii::app()->user->tools->save_symlink( basename($this->fusionconfig).".tmpl", $this->fusionconfig );
        // remove all the content from the content part
        $this->clear();
        
        $pull = new PullModeConfig;
        $pull->load();
        $pull->save();
        
		$this->needreload = true;
    }
    
    function disabling() {
    
        if ( $this->getActive() ) {
            //$this->clear();
            //exec('/etc/raperca/resetcontent');
            unlink( $this->fusionconfig );
            exec('sync'); // make sure data is commited before returning
			$this->needreload = true;
            
            $this->setStart( false );
            
            $pull = new PullModeConfig;
            $pull->setScenario('fusion');
            $pull->load();
            $pull->save();
        }        
    }
	function reloadConfig() {
        if ($this->needreload) {
            # Push everything to http server before reloading the server's config
            ob_flush();
            flush();
            # This must be at the very end, otherwise apache graceful restart
            # may still close the connection to the FastCGI server process running
            # this script.
            exec('/etc/init.d/apache reload < /dev/null > /dev/null 2> /dev/null &');
        }
            
    }
}
